import java.util.*;
import java.lang.*;

public class Main {
	static final int MAXN = 100010;
	static final int MAXL = 1000010;
	static int[] px = new int[MAXN];
	static int[] py = new int[MAXN];
	static int[] lx = new int[MAXL];
	static int[] ly = new int[MAXL];

	public static void main(String args[]){
		Scanner sc = new Scanner(System.in);

		int n = sc.nextInt();
		for(int i=0; i<n; i++){
			px[i] = sc.nextInt() + MAXL / 2;
			py[i] = sc.nextInt() + MAXL / 2;
		}
		
		for(int i=0; i<n; i++) {
			int j = (i+1) % n;
			if(px[i] == px[j]) {
				int y1 = py[i], y2 = py[j];
				if(y1 > y2) {
					int temp = y1; y1 = y2; y2 = temp;
				}
				ly[y1]++; ly[y2]--;
			}
			else {
				int x1 = px[i], x2 = px[j];
				if(x1 > x2) {
					int temp = x1; x1 = x2; x2 = temp;
				}
				lx[x1]++; lx[x2]--;
			}
		}

		for(int i=1;i<MAXL;i++) lx[i] += lx[i-1];
		for(int i=1;i<MAXL;i++) ly[i] += ly[i-1];

		int ans = 0;
		for(int i=0;i<MAXL;i++) if(ans < lx[i]) ans = lx[i];
		for(int i=0;i<MAXL;i++) if(ans < ly[i]) ans = ly[i];
		System.out.println(ans);
	}
}
